<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.6"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>HTTP: SHPP::Server Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">HTTP
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.6 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespaceSHPP.html">SHPP</a></li><li class="navelem"><a class="el" href="classSHPP_1_1Server.html">Server</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classSHPP_1_1Server-members.html">List of all members</a>  </div>
  <div class="headertitle"><div class="title">SHPP::Server Class Reference</div></div>
</div><!--header-->
<div class="contents">

<p>Class to create and run the HTTP server.  
 <a href="classSHPP_1_1Server.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="server_8h_source.html">server.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-types" name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a7815b7fd1249097aede0b5601901e094"><td class="memItemLeft" align="right" valign="top"><a id="a7815b7fd1249097aede0b5601901e094" name="a7815b7fd1249097aede0b5601901e094"></a>
using&#160;</td><td class="memItemRight" valign="bottom"><b>Handler</b> = std::function&lt; <a class="el" href="structSHPP_1_1Response.html">Response</a>(const <a class="el" href="structSHPP_1_1Request.html">Request</a> &amp;)&gt;</td></tr>
<tr class="memdesc:a7815b7fd1249097aede0b5601901e094"><td class="mdescLeft">&#160;</td><td class="mdescRight">An alias for the handler callback function. <br /></td></tr>
<tr class="separator:a7815b7fd1249097aede0b5601901e094"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-methods" name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab17fb726ec450fc49b892fb74c939460"><td class="memItemLeft" align="right" valign="top"><a id="ab17fb726ec450fc49b892fb74c939460" name="ab17fb726ec450fc49b892fb74c939460"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>Server</b> (const <a class="el" href="classSHPP_1_1Server.html#a7815b7fd1249097aede0b5601901e094">Handler</a> &amp;handler)</td></tr>
<tr class="memdesc:ab17fb726ec450fc49b892fb74c939460"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the server with the request handler. <br /></td></tr>
<tr class="separator:ab17fb726ec450fc49b892fb74c939460"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba79b20af03be27856da541350b662ca"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSHPP_1_1Server.html#aba79b20af03be27856da541350b662ca">set_address</a> (const std::string &amp;address)</td></tr>
<tr class="separator:aba79b20af03be27856da541350b662ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5aba82072355cce0d3aec6c49d589973"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSHPP_1_1Server.html#a5aba82072355cce0d3aec6c49d589973">set_port</a> (const uint16_t &amp;port)</td></tr>
<tr class="separator:a5aba82072355cce0d3aec6c49d589973"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1a4a206c82decb5aa85db417f168ad5b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSHPP_1_1Server.html#a1a4a206c82decb5aa85db417f168ad5b">set_handler</a> (const <a class="el" href="classSHPP_1_1Server.html#a7815b7fd1249097aede0b5601901e094">Handler</a> &amp;handler)</td></tr>
<tr class="separator:a1a4a206c82decb5aa85db417f168ad5b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad3ceec24e4a131346e8963fa26d38fa4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classSHPP_1_1Server.html#ad3ceec24e4a131346e8963fa26d38fa4">set_threads</a> (const size_t &amp;threads)</td></tr>
<tr class="separator:ad3ceec24e4a131346e8963fa26d38fa4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a91b9ebc0bdd1e1dc2beac293bb501a51"><td class="memItemLeft" align="right" valign="top"><a id="a91b9ebc0bdd1e1dc2beac293bb501a51" name="a91b9ebc0bdd1e1dc2beac293bb501a51"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>run</b> ()</td></tr>
<tr class="memdesc:a91b9ebc0bdd1e1dc2beac293bb501a51"><td class="mdescLeft">&#160;</td><td class="mdescRight">Run the HTTP server. <br /></td></tr>
<tr class="separator:a91b9ebc0bdd1e1dc2beac293bb501a51"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Class to create and run the HTTP server. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="aba79b20af03be27856da541350b662ca" name="aba79b20af03be27856da541350b662ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aba79b20af03be27856da541350b662ca">&#9670;&#160;</a></span>set_address()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void SHPP::Server::set_address </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>address</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Set the ip address of the server</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">address</td><td>the address of the server </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a1a4a206c82decb5aa85db417f168ad5b" name="a1a4a206c82decb5aa85db417f168ad5b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1a4a206c82decb5aa85db417f168ad5b">&#9670;&#160;</a></span>set_handler()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void SHPP::Server::set_handler </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classSHPP_1_1Server.html#a7815b7fd1249097aede0b5601901e094">Handler</a> &amp;&#160;</td>
          <td class="paramname"><em>handler</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Set the request handler function of the server</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">handler</td><td>request handler callbakc function </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a5aba82072355cce0d3aec6c49d589973" name="a5aba82072355cce0d3aec6c49d589973"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5aba82072355cce0d3aec6c49d589973">&#9670;&#160;</a></span>set_port()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void SHPP::Server::set_port </td>
          <td>(</td>
          <td class="paramtype">const uint16_t &amp;&#160;</td>
          <td class="paramname"><em>port</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Set the port of the server</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">port</td><td>port of the server </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ad3ceec24e4a131346e8963fa26d38fa4" name="ad3ceec24e4a131346e8963fa26d38fa4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad3ceec24e4a131346e8963fa26d38fa4">&#9670;&#160;</a></span>set_threads()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void SHPP::Server::set_threads </td>
          <td>(</td>
          <td class="paramtype">const size_t &amp;&#160;</td>
          <td class="paramname"><em>threads</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Set the number of threads of the server</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">threads</td><td>number of threads of the server </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/<a class="el" href="server_8h_source.html">server.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.6
</small></address>
</body>
</html>
